/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.workflow.action;

import jp.mosp.common.CommonConst;
import jp.mosp.common.action.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;

import jp.mosp.system.dao.MCodeDao;
import jp.mosp.system.dto.MCodeDto;
import jp.mosp.workflow.vo.ApprovalFunctionCardVo;

public class ApprovalFunctionCardAction extends MosPAction {

	// コマンド
	private static final String CMD_FUNCTION_CARD_SHOW   = "S2840";	// 表示
	private static final String CMD_FUNCTION_CARD_UPDATE = "S2848";	// 更新

	/**
	 * コンストラクタ
	 */
	public ApprovalFunctionCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得及び設定
		ApprovalFunctionCardVo vo = new ApprovalFunctionCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DAOの宣言
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTOの取得
		MCodeDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MCodeDto ? (MCodeDto)obj : null;
		// プルダウンのセット
		vo.aryPltState = getDeleteArray();
		// コマンド毎の処理
		if (cmd.equals(CMD_FUNCTION_CARD_SHOW)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = dao.findForKey(CommonConst.TID_APPROVAL_FUNCTION, CommonConst.TCD_ATTENDANCE_APPROVAL);
			if (chkExistDto(dto)) {
				// VOに情報をセット
				vo.setFields(dto);
			} else {
				dto = new MCodeDto();
				// 初期値は「無効」
				dto.setTName(String.valueOf(MospConst.DELETE_FLAG_ON));
				vo.setFields(dto);
				vo.setMessage(CommonConst.MSG_ATTENDANCE_APPROVAL_FUNCTION1);
			}
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else if (cmd.equals(CMD_FUNCTION_CARD_UPDATE)) {
			// 更新
			dto = update(vo, dto);
			vo.setFields(dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MCodeDto update(ApprovalFunctionCardVo vo, MCodeDto dto) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DAOの宣言
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの確認
		if (chkExistDto(dao.findForUpdate(CommonConst.TID_APPROVAL_FUNCTION, CommonConst.TCD_ATTENDANCE_APPROVAL))) {
			// データの更新
			dao.update(dto);			
		} else {
			// データの登録
			dao.insert(dto);
		}
		// DTOの再取得		
		MCodeDto retDto = dao.findForKey(CommonConst.TID_APPROVAL_FUNCTION, CommonConst.TCD_ATTENDANCE_APPROVAL);
		chkUpdate(retDto);
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;
	}

}
